
local love = love

function love.conf(t)
  t.console = true
end

local function printf(...)
	print(...)
	-- io.flush()
end

local resume = coroutine.resume

local ts = {}
function love.load()
    local function create(file)
      fn = assert(loadfile(file))
      return coroutine.create(fn)
    end
    ts[1] = create("thread_sleep.lua")
    ts[2] = create("thread_sleep.lua")
    ts[3] = create("thread.lua")
    ts[4] = create("thread.lua")
    ts[5] = create("thread_sleep.lua")
    ts[6] = create("thread.lua")
    for i,t in ipairs(ts) do
      resume(t, i)
    end
end

local x, y = 0, 0
local results = {}
function love.update(dt)
    x = x + dt
    y = y + dt
    if y >= 1 then
        y = y - 1
        printf("gametime: "..math.floor(x))
    end

    for i,t in ipairs(ts) do
        local _,msg = assert(resume(t))
        if msg ~= "no line" then
            printf("main "..i..": "..msg)
            results[i] = msg
        end
    end
end

function love.draw()
    love.graphics.print("gametime: "..math.floor(x), 10, 10)
    love.graphics.print("thread sleep 1: "..tostring(results[1]), 10, 30)
    love.graphics.print("thread sleep 2: "..tostring(results[2]), 10, 50)
    love.graphics.print("thread 3: "..tostring(results[3]), 10, 70)
    love.graphics.print("thread 4: "..tostring(results[4]), 10, 90)
    love.graphics.print("thread sleep 5: "..tostring(results[5]), 10, 110)
    love.graphics.print("thread 6: "..tostring(results[6]), 10, 130)
end
