local posix = require "posix"

local rpoll = posix.rpoll
local fileno = posix.fileno

local love = love

local function printf(...)
	print(...)
	-- io.flush()
end

local name = ...

coroutine.yield()

printf("thread "..name..": starting...")

local p = assert(io.popen("python3 test.py", "r"))
printf("thread "..name..": test.py process: " .. tostring(p))

local n = 0
while p do
	local read = false
	if rpoll(fileno(p), 0) == 1 then
		local line = p:read("*l")
		if line then
			printf("thread "..name..": "..tostring(line))
			coroutine.yield("thread "..name..": read line "..n)
			n = n + 1
			read = true
		end
	end
	if not read then
		coroutine.yield("no line")
	end
end

p:close()
